SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'BB 6/18/2012 15:33' prior: 0!
A SBECell is a specific class for the SBE-Game.

Instance Variables
	mouseAction:		<Object>

mouseAction
	- xxxxx
!

!SBECell methodsFor: 'initialization' stamp: 'BB 6/18/2012 15:36'!
initialize
	"initialize this object"
	super initialize.
	self label: ''.
	self borderWidth:2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'accessing' stamp: 'BB 6/19/2012 14:29'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'accessing' stamp: 'BB 6/19/2012 14:29'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'game logic' stamp: 'BB 6/19/2012 13:59'!
cellsPerSide
	"The number of cells along each side of the game"
	^ 10! !

!SBEGame methodsFor: 'initialization' stamp: 'BB 6/19/2012 13:54'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'game logic' stamp: 'BB 6/19/2012 14:36'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i-1)*c width) @ ((j-1)*c height)+origin.
	c mouseAction: [self toggleNeighborsOfCellAt: i at: j].
	 ^ c	! !

!SBEGame methodsFor: 'game logic' stamp: 'BB 6/19/2012 14:13'!
toggleNeighborsOfCellAt: i at: j
	(i>1) ifTrue: [(cells at: i-1 at: j) toggleState].
	(i< self cellsPerSide) ifTrue: [(cells at: i+1 at: j) toggleState].
	(j >1) ifTrue: [(cells at: i at: j-1) toggleState].
	(j< self cellsPerSide) ifTrue: [(cells at: i at: j+1) toggleState].! !
